package controllers

import (
	"context"
	"fmt"

	routev1 "github.com/openshift/api/route/v1"
	authzalpha1 "gitlab.cern.ch/paas-tools/operators/authz-operator/api/v1alpha1"
	webservicescernchv1alpha1 "gitlab.cern.ch/paas-tools/operators/gitlab-pages-site-operator/api/v1alpha1"
	v1 "k8s.io/api/core/v1"
	kerrors "k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/api/meta"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/apimachinery/pkg/types"
	"k8s.io/apimachinery/pkg/util/intstr"
	"sigs.k8s.io/controller-runtime/pkg/client"
	"sigs.k8s.io/controller-runtime/pkg/controller/controllerutil"
)

const blockedServiceName = "invalid-service-endpoint-for-blocked-projects"
const blockedServicePort = 8080

func (r *GitlabPagesSiteReconciler) getOidcSecret(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite) (*v1.Secret, error) {
	appReg := &authzalpha1.ApplicationRegistration{}

	// By default an ApplicationRegistration is created with a name derived from the owning namespace
	appRegistrationName := types.NamespacedName{Namespace: gitlabPagesSite.Namespace, Name: gitlabPagesSite.Namespace}

	if err := r.Get(ctx, appRegistrationName, appReg); err != nil {
		if kerrors.IsNotFound(err) {
			return nil, fmt.Errorf("ApplicationRegistration %v was not found, either it wasn't created or it was deleted", appRegistrationName.Name)
		} else {
			r.logger.Error(err, "Failed to fetch ApplicationRegistration")
			return nil, err
		}
	}

	// Ensure we have a valid ApplicationRegistration. This can happen when the ApplicationRegistration is `Created` (the website should be up and running)
	// or when the ApplicationRegistration has state `DeletedFromAPI` (the website should be blocked). To check if the ApplicationRegistration is in one of those two states,
	// we can check if the oidc secret exists.
	if appReg.Status.ClientCredentialsSecret == "" {
		meta.SetStatusCondition(&gitlabPagesSite.Status.Conditions, metav1.Condition{
			Type:    webservicescernchv1alpha1.ConditionTypeGitlabPagesSiteCreated,
			Status:  metav1.ConditionFalse,
			Reason:  webservicescernchv1alpha1.ConditionReasonMissingApplicationRegistration,
			Message: "Waiting for site registration in Application Portal",
		})

		if err := r.Status().Update(ctx, gitlabPagesSite); err != nil {
			return nil, err
		}

		err := fmt.Errorf("ApplicationRegistration %v still doesn't have ClientCredentialsSecret set to oidc-client-secret", appReg.Name)
		r.logger.Info(err.Error())
		return nil, err
	}

	// Retrieve OIDC secret
	oidcSecret := &v1.Secret{}
	namespacedName := types.NamespacedName{
		Name:      appReg.Status.ClientCredentialsSecret,
		Namespace: gitlabPagesSite.Namespace,
	}

	if err := r.Get(ctx, namespacedName, oidcSecret); err != nil {
		r.logger.Error(err, "Failed to get the OIDC client secret generated by the ApplicationRegistration CR in the GitlabPagesSite namespace")
		return nil, err
	}

	// Validate that the secret contains the required data
	requiredFields := []string{"clientID", "clientSecret", "issuerURL"}
	for _, field := range requiredFields {
		if value, exists := oidcSecret.Data[field]; !exists || len(value) == 0 {
			return nil, fmt.Errorf("secret '%s' in namespace '%s' is missing required field or has empty value: %s", appReg.Status.ClientCredentialsSecret, gitlabPagesSite.Namespace, field)
		}
	}

	return oidcSecret, nil
}

func (r *GitlabPagesSiteReconciler) ensureGitlabPagesSiteHttpdConfig(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite, secret, oidcSecret *v1.Secret) error {
	_, err := controllerutil.CreateOrUpdate(ctx, r.Client, secret, func() error {
		if secret.Data == nil {
			secret.Data = map[string][]byte{}
		}

		httpdConfig, err := generateHttpdVhostConfiguration(gitlabPagesSite, oidcSecret, r.GitlabPagesURL, r.OIDCReturnPath)
		if err != nil {
			return err
		}

		secret.Data[generateSecretKey(gitlabPagesSite)] = httpdConfig

		return nil
	})

	return err
}

// ensureRoute ensures the existence of a Route for a given GitlabPagesSite
func (r *GitlabPagesSiteReconciler) ensureRoutes(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite) error {
	hosts := gitlabPagesSite.Spec.Hosts
	actualRoutes := map[string]bool{}

	// Get namespace needed to manage some configuration with namespace annotations / labels
	namespace := &v1.Namespace{}
	if err := r.Get(ctx, types.NamespacedName{Namespace: gitlabPagesSite.Namespace, Name: gitlabPagesSite.Namespace}, namespace); err != nil {
		return err
	}
	// the router shard to use for the routes associated with this GitlabPagesSite
	// the default can be overriden with a namespace annotation (same annotation as for webeos site)
	routerShard := namespace.Annotations[forceRouterShardNamespaceAnnotation]
	if routerShard == "" {
		routerShard = r.DefaultRouterShard
	}
	// evaluates to an empty string (= allow any IP) if no such annotation on namespace
	routeIpWhitelist := namespace.Annotations[forceIpWhitelistNamespaceAnnotation]

	for _, host := range hosts {
		route := &routev1.Route{
			ObjectMeta: metav1.ObjectMeta{
				Name:      generateRouteName(gitlabPagesSite, string(host)),
				Namespace: r.Namespace,
			},
		}

		_, err := controllerutil.CreateOrUpdate(ctx, r.Client, route, func() error {
			if route.Annotations == nil {
				route.Annotations = map[string]string{}
			}

			if route.Labels == nil {
				route.Labels = map[string]string{}
			}

			// annotation used in the custom Watches function
			route.Annotations[gitlabPagesSiteRouteOwnershipAnnotation] = types.NamespacedName{Name: gitlabPagesSite.Name, Namespace: gitlabPagesSite.Namespace}.String()
			route.Labels[gitlabPagesSiteRouteOwnershipLabel] = generateOwnershipLabelValue(gitlabPagesSite)

			if r.RouterShardLabel != "" && routerShard != "" {
				// assign the Route to the desired router shard
				route.Labels[r.RouterShardLabel] = routerShard
			}
			route.Annotations["haproxy.router.openshift.io/ip_whitelist"] = routeIpWhitelist

			// if the host doesn't match the shared domain regex, we will make sure a certificate is automatically provisioned
			if r.SharedSubdomainRegex != nil && !r.SharedSubdomainRegex.MatchString(string(host)) {
				route.Annotations["kubernetes.io/tls-acme"] = "true"
			}

			route.Spec.Host = string(host)

			// make sure we don't accidentally nullify other fields that may be set by other
			// components, e.g. openshift-acme which can automatically generate LE certificate for a Route (and then use
			// it to update Route's TLS configuration)
			if route.Spec.TLS == nil {
				route.Spec.TLS = &routev1.TLSConfig{
					InsecureEdgeTerminationPolicy: "Redirect",
					Termination:                   "edge",
				}
			} else {
				route.Spec.TLS.InsecureEdgeTerminationPolicy = "Redirect"
				route.Spec.TLS.Termination = "edge"
			}

			route.Spec.To = routev1.RouteTargetReference{
				Kind: "Service",
				Name: r.AuthProxyServiceName,
			}
			route.Spec.Port = &routev1.RoutePort{
				TargetPort: intstr.FromInt(r.AuthProxyServicePort),
			}
			// If the project is blocked, we redirect the traffic to a non-existing service endpoint
			// In this case, HAProxy routers will return a "503 Application not available" message
			if projectBlocked(*namespace) {
				route.Spec.To.Name = blockedServiceName
				route.Spec.Port.TargetPort = intstr.FromInt(blockedServicePort)
			}

			return nil
		})

		if err != nil {
			return err
		}

		actualRoutes[route.Name] = true
	}

	ownedRoutes, err := r.getRoutes(ctx, gitlabPagesSite)
	if err != nil {
		return err
	}

	for _, route := range ownedRoutes.Items {
		if _, ok := actualRoutes[route.Name]; !ok {
			// route should be deleted since it is not part of the Spec.Hosts
			err := r.Client.Delete(ctx, &route)
			if err != nil {
				return err
			}
		}
	}

	return nil
}

func (r *GitlabPagesSiteReconciler) getRoutes(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite) (routev1.RouteList, error) {
	routes := &routev1.RouteList{}
	labelSelector := &metav1.LabelSelector{MatchLabels: map[string]string{gitlabPagesSiteRouteOwnershipLabel: generateOwnershipLabelValue(gitlabPagesSite)}}
	listOptions := &client.ListOptions{Namespace: r.Namespace, LabelSelector: labels.Set(labelSelector.MatchLabels).AsSelector()}
	err := r.Client.List(ctx, routes, listOptions)
	return *routes, err
}

func (r *GitlabPagesSiteReconciler) ensureOIDCReturnURIs(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite) error {
	hosts := gitlabPagesSite.Spec.Hosts
	actualUris := map[string]bool{}
	for _, host := range hosts {
		oidcReturnURI := &authzalpha1.OidcReturnURI{}
		// We have to do this part here as MutateFn cannot mutate object
		// name and/or object namespace
		oidcReturnURI.Name = generateOidcReturnUriName(gitlabPagesSite, string(host))
		oidcReturnURI.Namespace = gitlabPagesSite.Namespace

		_, err := controllerutil.CreateOrUpdate(ctx, r.Client, oidcReturnURI, func() error {
			if oidcReturnURI.Labels == nil {
				oidcReturnURI.Labels = map[string]string{}
			}

			oidcReturnURI.Labels[gitlabPagesSiteRouteOwnershipLabel] = generateOwnershipLabelValue(gitlabPagesSite)
			oidcReturnURI.Spec.RedirectURI = getOIDCReturnUri(string(host), r.OIDCReturnPath)
			// Set GitlabPagesSite as the owner and controller. This will set
			// the OwnerReferences on the oidcReturnURI, and will trigger a deletion of the
			// oidcReturnURI when the corresponding GitlabPagesSite gets deleted.
			return controllerutil.SetControllerReference(gitlabPagesSite, oidcReturnURI, r.Scheme)
		})

		if err != nil {
			return err
		}

		actualUris[oidcReturnURI.Name] = true
	}

	oidcReturnUris, err := r.getOIDCReturnUris(ctx, gitlabPagesSite)
	if err != nil {
		return err
	}

	for _, oidcUri := range oidcReturnUris.Items {
		if _, ok := actualUris[oidcUri.Name]; !ok {
			err := r.Client.Delete(ctx, &oidcUri)
			if err != nil {
				return err
			}
		}
	}

	return nil
}

func (r *GitlabPagesSiteReconciler) getOIDCReturnUris(ctx context.Context, gitlabPagesSite *webservicescernchv1alpha1.GitlabPagesSite) (authzalpha1.OidcReturnURIList, error) {
	oidcReturnUris := &authzalpha1.OidcReturnURIList{}
	labelSelector := &metav1.LabelSelector{MatchLabels: map[string]string{gitlabPagesSiteRouteOwnershipLabel: generateOwnershipLabelValue(gitlabPagesSite)}}
	listOptions := &client.ListOptions{Namespace: gitlabPagesSite.Namespace, LabelSelector: labels.Set(labelSelector.MatchLabels).AsSelector()}
	err := r.Client.List(ctx, oidcReturnUris, listOptions)
	return *oidcReturnUris, err
}

// returns all GPS CRs in a given namespace
func (r *GitlabPagesSiteReconciler) getGitlabPagesSitesInNamespace(ctx context.Context, namespace string) (webservicescernchv1alpha1.GitlabPagesSiteList, error) {
	gitlabPagesSiteList := &webservicescernchv1alpha1.GitlabPagesSiteList{}
	options := &client.ListOptions{
		Namespace: namespace,
	}
	err := r.Client.List(ctx, gitlabPagesSiteList, options)
	return *gitlabPagesSiteList, err
}
